;; Public test cases for problem set 1
(load "search.scm")
(load "ps2.scm")
(load "tester-utils.scm")

(begin-test-suite)

(begin
  (test-true-false 1 'answer-1.5.0)
  (test-true-false 1 'answer-1.5.1)
  (test-true-false 1 'answer-1.5.2)
  (test-true-false 1 'answer-1.5.3)
  (test-true-false 1 'answer-1.5.4)
  (test-true-false 1 'answer-1.5.5)
  (test-true-false 1 'answer-1.5.6)
  
  (test-multiple-answers 1 '(search "BFS" #t thegraph "TheChamber" "CommonArea")
         '(((EXTENDED-NODES
             ("TheChamber" 
              "HauntedBathroom" 
              "Dungeon5" 
              "EntranceHall" 
              "Hospital" 
              "GrandHall" 
              "Classroom 11" 
              "Stairs" 
              "CommonArea"))
            (SOLUTION-PATH ("TheChamber" "HauntedBathroom" "EntranceHall" "Stairs" "CommonArea")))
           ((EXTENDED-NODES ("TheChamber" "HauntedBathroom" "EntranceHall" "Dungeon5" "Stairs" "Classroom 11" "GrandHall" "Hospital" "MirroredRoom" "TrophyRoom" "ForbiddenArea" "Statues" "CommonArea")) (SOLUTION-PATH ("TheChamber" "HauntedBathroom" "EntranceHall" "Stairs" "CommonArea"))))
        ) 
  
  (test-multiple-answers 1 '(search "BFS" #f thegraph "Hospital" "CommonArea")
        '(((EXTENDED-NODES
           ("Hospital"
            "EntranceHall"
            "Classroom 11"
            "GrandHall"
            "HauntedBathroom"
            "Classroom 11"
            "Stairs"
            "EntranceHall"
            "Stairs"
            "TheChamber"
            "Dungeon5"
            "CommonArea"))
          (SOLUTION-PATH ("Hospital" "EntranceHall" "Stairs" "CommonArea")))
          ((EXTENDED-NODES ("Hospital" "Classroom 11" "EntranceHall" "EntranceHall" "Stairs" "Classroom 11" "HauntedBathroom" "GrandHall" "Stairs" "HauntedBathroom" "GrandHall" "MirroredRoom" "TrophyRoom" "ForbiddenArea" "Statues" "GrandHall" "CommonArea")) (SOLUTION-PATH ("Hospital" "EntranceHall" "Stairs" "CommonArea")))))
  
  (test-multiple-answers 1 '(search "DFS" #t thegraph "Dungeon5" "MirroredRoom")
        '(((EXTENDED-NODES
           ("Dungeon5"
            "HauntedBathroom"
            "TheChamber"
            "EntranceHall"
            "Hospital"
            "Classroom 11"
            "GrandHall"
            "Stairs"
            "CommonArea"
            "NecessaryRoom"
            "Statues"
            "MirroredRoom"))
          (SOLUTION-PATH ("Dungeon5" "HauntedBathroom" "EntranceHall" "GrandHall" "Stairs" "Statues" "MirroredRoom")))
          ((EXTENDED-NODES ("Dungeon5" "HauntedBathroom" "EntranceHall" "Stairs" "MirroredRoom")) (SOLUTION-PATH ("Dungeon5" "HauntedBathroom" "EntranceHall" "Stairs" "MirroredRoom")))))
  
  (test-multiple-answers 1 '(search "DFS" #f thegraph "Classroom 11" "NecessaryRoom")
        '(((EXTENDED-NODES ("Classroom 11" "Hospital" "EntranceHall" "GrandHall" "Stairs" "CommonArea" "NecessaryRoom"))
          (SOLUTION-PATH ("Classroom 11" "Hospital" "EntranceHall" "GrandHall" "Stairs" "CommonArea" "NecessaryRoom")))
          ((EXTENDED-NODES ("Classroom 11" "EntranceHall" "Stairs" "MirroredRoom" "Statues" "TrophyRoom" "ForbiddenArea" "ForbiddenArea" "TrophyRoom" "Statues" "MirroredRoom" "GrandHall" "CommonArea" "NecessaryRoom")) (SOLUTION-PATH ("Classroom 11" "EntranceHall" "Stairs" "CommonArea" "NecessaryRoom")))))
  
  (test 1 '(search "HC" #t thegraph "Hospital" "CommonArea") 
        '((EXTENDED-NODES ("Hospital" "EntranceHall" "Stairs" "CommonArea"))
          (SOLUTION-PATH ("Hospital" "EntranceHall" "Stairs" "CommonArea"))))

  (test-multiple-answers 1 '(search "HC" #t graph3 "S" "G")
                         '(((EXTENDED-NODES ("S" "A" "D" "G")) 
                            (SOLUTION-PATH ("S" "A" "D" "G")))
                           ((EXTENDED-NODES ("S" "A" "B" "C" "G"))
                            (SOLUTION-PATH ("S" "A" "B" "C" "G")))))
  
  (test 1 '(search "HC" #t graph2 "S" "G")
        '((EXTENDED-NODES ("S" "A" "C" "E" "G"))
          (SOLUTION-PATH ("S" "A" "C" "E" "G"))))
        
  (test 1 '(search "HC" #f thegraph "Dungeon5" "CommonArea") 
        '((EXTENDED-NODES ("Dungeon5" "HauntedBathroom" "EntranceHall" "Stairs" "CommonArea"))
          (SOLUTION-PATH ("Dungeon5" "HauntedBathroom" "EntranceHall" "Stairs" "CommonArea"))))

  (test 1 '(path-length '("NecessaryRoom" "CommonArea" "Stairs" "EntranceHall" "HauntedBathroom" "TheChamber") (get-edges thegraph)) 47)
  
  (test 1 '(path-length '("Dungeon5" "HauntedBathroom" "EntranceHall" "Stairs" "TrophyRoom" "Stairs" "MirroredRoom" "Statues" "Stairs" "GrandHall" "EntranceHall" "Classroom 11" "Hospital") (get-edges thegraph)) 63)
  
  (test-multiple-answers 1 '(search "Branch and Bound" #t thegraph "MirroredRoom" "ForbiddenArea") 
                         '(((EXTENDED-NODES ("MirroredRoom" "Statues" "Stairs" "GrandHall" "EntranceHall" "ForbiddenArea"))
                            (SOLUTION-PATH ("MirroredRoom" "Stairs" "ForbiddenArea")))
                           ((EXTENDED-NODES ("MirroredRoom" "Statues" "Stairs" "EntranceHall" "GrandHall" "ForbiddenArea"))
                            (SOLUTION-PATH ("MirroredRoom" "Stairs" "ForbiddenArea")))))
 
  (test 1 '(search "Branch and Bound" #t graph2 "S" "G") 
                         '((EXTENDED-NODES ("S" "B" "A" "C" "D" "E" "G"))
                            (SOLUTION-PATH ("S" "B" "C" "E" "G"))))
  
    (test 1 '(search "Branch and Bound" #f thegraph "Dungeon5" "EntranceHall") 
                         '((EXTENDED-NODES ("Dungeon5" "HauntedBathroom" "EntranceHall"))
                           (SOLUTION-PATH ("Dungeon5" "HauntedBathroom" "EntranceHall"))))

    (test-multiple-answers 1 '(search "Branch and Bound" #f graph2 "B" "G")
                           '(((EXTENDED-NODES ("B" "S" "C" "A" "D" "A" "E" "G"))
                              (SOLUTION-PATH ("B" "C" "E" "G")))
                             ((EXTENDED-NODES ("B" "S" "C" "A" "D" "E" "A" "G"))
                              (SOLUTION-PATH ("B" "C" "E" "G")))
                             ((EXTENDED-NODES ("B" "S" "C" "A" "D" "E" "A" "E" "G"))
                              (SOLUTION-PATH ("B" "C" "E" "G")))
                             ((EXTENDED-NODES ("B" "S" "C" "A" "D" "A" "E" "E" "G"))
                              (SOLUTION-PATH ("B" "C" "E" "G")))))
          
    (test-multiple-answers 1 '(search "Branch and Bound" #f graph3 "S" "G")
                           '(((EXTENDED-NODES ("S" "B" "A" "C" "D" "D" "C" "A" "A" "G")) 
                              (SOLUTION-PATH ("S" "B" "C" "G")))
                             ((EXTENDED-NODES ("S" "B" "A" "C" "D" "D" "A" "C" "A" "G")) 
                              (SOLUTION-PATH ("S" "B" "C" "G")))
                             ((EXTENDED-NODES ("S" "B" "A" "C" "D" "D" "C" "A" "G")) 
                              (SOLUTION-PATH ("S" "B" "C" "G")))
                             ((EXTENDED-NODES ("S" "B" "A" "C" "D" "D" "A" "C" "G")) 
                              (SOLUTION-PATH ("S" "B" "C" "G")))))
    
   
    (test 1 '(search "Branch and Bound" #t graph3 "S" "G")
          '((EXTENDED-NODES ("S" "B" "A" "C" "D" "G")) (SOLUTION-PATH ("S" "B" "C" "G"))))
          
    (test 1 '(search "A*" #t thegraph "MirroredRoom" "CommonArea") 
          '((EXTENDED-NODES ("MirroredRoom" "Stairs" "CommonArea")) 
            (SOLUTION-PATH ("MirroredRoom" "Stairs" "CommonArea"))))
          
    (test 1 '(search "A*" #t graph2 "S" "G") 
                           '((EXTENDED-NODES ("S" "B" "C" "E" "G")) 
                             (SOLUTION-PATH ("S" "B" "C" "E" "G"))))
    
    (test 1 '(search "A*" #t thegraph "GrandHall" "CommonArea")
                           '((EXTENDED-NODES ("GrandHall" "Stairs" "CommonArea")) 
                           (SOLUTION-PATH ("GrandHall" "Stairs" "CommonArea"))))

    (test 1 '(search "A*" #t graph3 "C" "S") 
          '((EXTENDED-NODES ("C" "G" "D" "A" "B" "S")) (SOLUTION-PATH ("C" "B" "S"))))
    
    (test 1 '(search "A*" #t graph5 "S" "G")
          '((EXTENDED-NODES ("S" "B" "C" "G")) (SOLUTION-PATH ("S" "B" "C" "G"))))
    
    (test 1 '(isAdmissibleAndConsistent? thegraph) #t)
    
    (test 1 '(isAdmissibleAndConsistent? graph2) #f)
    
    (test 1 '(isAdmissibleAndConsistent? graph3) #t)
    
    (test 1 '(isAdmissibleAndConsistent? graph4) #f)
    
    (test 1 '(isAdmissibleAndConsistent? graph5) #f)
    
    (test-short-answer 0 'how-many-hours-this-pset-took)
    (test-short-answer 0 'what-i-found-interesting)
    (test-short-answer 0 'what-i-found-boring)
    
    (end-test-suite))

