;; Public test cases for problem set 4
(load "id-trees.scm")
(load "tester-utils.scm")
(load "ps4.scm")

(begin-test-suite)

;; Problem 1
(begin
  
  (test 1 '(euclidean-distance '(0 0 0) '(0 0 1)) 1)
  (test 1 '(< (abs (- (euclidean-distance '(1 2) '(3 4)) 2.828)) .001) #t)
  
  (test 1 '(hamming-distance '(1 2 3 4) '(4 4 4 4)) 3)
  (test 1 '(hamming-distance '(yes no no yes) '(yes no no no)) 1)
  (test 1 '(hamming-distance '(yes no maybe) '(yes no no)) 1)
  
  (test 1 '(< (abs (- (cos-theta '(5 0 3 4) '(3 2 2 6)) 0.874)) .001) #t)
  (test 1 '(< (abs (- (cos-theta '(1 1 1) '(1 2 3)) 0.926)) .001) #t)
  
  
  (define nn1 (make-nn-classifier hamming-distance train-data-simple))
  (test 1 '(nn1 '(2 1 2)) "mammal")
  (test 1 '(nn1 '(1 2 2)) "reptile")
  (test 1 '(nn1 '(2 1 1)) "mammal")
  (test 1 '(nn1 '(1 2 1)) "reptile")
  
  
  (define nn2 (make-nn-classifier hamming-distance train-data-small))
  (test 1 '(nn2 '(no no no yes yes yes no no no yes no yes no yes no yes)) "republican")
  (test 1 '(nn2 '(no no yes no no no yes yes yes no no no no no yes yes)) "democrat")
  (test 1 '(nn2 '(yes no yes no no yes yes yes no no no yes yes no no yes)) "democrat")
  (test 1 '(nn2 '(yes yes yes no no no yes yes maybe yes no no no no yes maybe)) "democrat")
  (test 1 '(nn2 '(no no no yes yes yes yes no no yes no no no yes yes yes)) "republican")
  (test 1 '(nn2 '(maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe)) "democrat")
  
  
  (define nn3 (make-nn-classifier hamming-distance train-data-large))
  (test 1 '(nn3 '(yes yes yes yes no yes no no no yes no yes no yes no yes)) "republican")
  (test 1 '(nn3 '(no no yes no no no yes yes yes no no no no no yes yes)) "democrat")
  (test 1 '(nn3 '(yes no yes no no yes yes yes no no no yes yes no no yes)) "democrat")
  (test 1 '(nn3 '(yes yes yes no no no yes yes maybe yes no no no no yes maybe)) "democrat")
  (test 1 '(nn3 '(no no no yes yes yes yes no no yes no no no yes yes yes)) "republican")
  (test 1 '(nn3 '(maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe)) "republican")
  
  ;; Try k-nn with k=1 as a sanity check
  (define k-nn1 (make-k-nn-classifier 1 hamming-distance train-data-small))
  (test 1 '(k-nn1 '(no no no yes yes yes no no no yes no yes no yes no yes)) "republican")
  (test 1 '(k-nn1 '(no no yes no no no yes yes yes no no no no no yes yes)) "democrat")
  (test 1 '(k-nn1 '(yes no yes no no yes yes yes no no no yes yes no no yes)) "democrat")
  (test 1 '(k-nn1 '(yes yes yes no no no yes yes maybe yes no no no no yes maybe)) "democrat")
  (test 1 '(k-nn1 '(no no no yes yes yes yes no no yes no no no yes yes yes)) "republican")
  (test 1 '(k-nn1 '(maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe)) "democrat")  
  
  (define k-nn3 (make-k-nn-classifier 3 hamming-distance train-data-small))
  (test 1 '(k-nn3 '(no no no no yes yes yes no no no no maybe no yes yes yes)) "republican")
  (test 1 '(k-nn3 '(no yes yes no no no yes yes maybe yes no no yes no yes yes)) "democrat")
  (test 1 '(k-nn3 '(yes no yes no no no no yes yes yes no no no no yes yes)) "democrat")
  (test 1 '(k-nn3 '(yes no yes no no no yes yes yes yes yes no no no yes yes)) "democrat")
  (test 1 '(k-nn3 '(no no yes no yes no yes yes yes no no no no yes maybe yes)) "democrat")
  (test 1 '(k-nn3 '(no yes no yes yes yes maybe no no no no maybe yes yes no no)) "republican")
  (test 1 '(k-nn3 '(maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe maybe)) "democrat")
  
  (define k-nn5 (make-k-nn-classifier 5 hamming-distance train-data-large))  
  (test 1 '(k-nn5 '(yes yes maybe maybe maybe yes no no no no yes no yes no no yes)) "democrat")
  (test 1 '(k-nn5 '(yes yes yes maybe no no no yes no no yes maybe no no yes yes)) "democrat") 
  (test 1 '(k-nn5 '(yes yes yes no yes yes no yes no no yes no yes no yes yes)) "democrat")
  (test 1 '(k-nn5 '(no yes no yes maybe yes no no no yes no yes yes yes no no)) "republican")
  (test 1 '(k-nn5 '(no yes no yes yes yes no maybe no no maybe maybe maybe yes no maybe)) "republican")
  
  (test 1 '(basic-disorder lotion-attribute-spec '("sunburned" "none") sunburn-data) -3)
  (test 1 '(basic-disorder height-attribute-spec '("sunburned" "none") sunburn-data) -2)  
  (test 1 '(basic-disorder weight-attribute-spec '("sunburned" "none") sunburn-data) 0)  
  (test 1 '(basic-disorder haircolor-attribute-spec '("sunburned" "none") sunburn-data) -4)  
  (test 1 '(basic-disorder lotion-attribute-spec '("sunburned" "none") blonde-subset) -4)  
  
  (define congress-id-classifier (make-idtree-classifier congress-attribute-specs train-data-large))
  (test 2 '(cadr (car (validate-classifier congress-id-classifier test-data-small))) 24)
  (test 2 '(cadr (car (validate-classifier congress-id-classifier test-data-large))) 95)
  
  
  (test-short-answer 0 "-")
  (test-short-answer 0 "-")
  (test-short-answer 0 "-")
  
  (end-test-suite))
