;; Public test cases for problem set 5
(load "tester-utils.scm")
(load "ps5.scm")

(begin-test-suite)

(begin
;; SVMs 
  (test-multiple-answers 3 'answer-1.1 '((.5 .5) (1/2 1/2)))
  (test-threshold 3 'answer-1.2 (* 2 (sqrt 2)) 0.001)
  (test 1 '(number? answer-1.3) #t)
  (test-true-false 1 'answer-1.4)
  (test-true-false 1 'answer-1.5)
 
;; Boosting
  
  ; Make sure that data is reweighted correctly.
  (define silly-data
    (list
     (make-datum 1 #t 1)
     (make-datum 1 #f 0)
     (make-datum 1 #t 1)))
  (test 1 '(reweight-data (lambda (x) 0) silly-data (/ 2 3)) '((0.25 #t . 1) (0.5 #f . 0) (0.25 #t . 1)))
  (test 1 '(reweight-data (lambda (x) 1) silly-data (/ 1 3)) '((0.25 #t . 1) (0.5 #f . 0) (0.25 #t . 1)))
  
  ; First, use a simple base classifier.
  (define boost (make-boost-classifier train-data-small make-base-classifier
                                       congress-attribute-specs 1))
  (test-threshold 1 '(car (car (boost 'data))) 0.020833333 0.001)
  
  (test 1 '(length (boost 'describe)) 1)
  (test-threshold 1 '(car (car (boost 'describe))) 1.589 0.001)
  (test 1 '(cadr (car (boost 'describe))) '("Physician Fee Freeze" yes 1))
  
  (test-threshold 1 '(car (hardest-example boost)) 0.5 0.001)
  (test 1 '(cdr (hardest-example boost)) '((no yes no yes no yes yes yes yes no yes no yes no yes maybe) . -1))
  
  (test-threshold 2 '(classifier-error-rate boost train-data-small) 0.04 0.001)
   
  ; Now train a boost classifier with T=5.
  (define boost (make-boost-classifier train-data-small make-base-classifier
                                       congress-attribute-specs 5))
  (test-threshold 1 '(car (car (boost 'data))) 0.0015528 0.001)
  
  (test 1 '(length (boost 'describe)) 5)
  (test-threshold 1 '(car (car (boost 'describe))) 1.589 0.001)
  (test 1 '(cadr (cadr (boost 'describe))) '("Aid to El Salvador" yes 1))
  
  (test-threshold 1 '(car (hardest-example boost)) 0.5 0.001)
  (test 1 '(cdr (hardest-example boost)) '((no yes no yes no yes yes yes yes no yes no yes no yes maybe) . -1))
  
  (test-threshold 2 '(classifier-error-rate boost train-data-small) 0 0.001)
  
  
  ; train for 15 steps on large data; test on large testing data
  (define boost (make-boost-classifier train-data-large make-base-classifier
                                       congress-attribute-specs 15))

  (test 2 '(cdr (hardest-example boost)) '((no no no yes yes yes no no no no yes yes yes yes no no) . -1))
  (test-threshold 2 '(classifier-error-rate boost train-data-large) 0.0202 0.001)
  (test-threshold 2 '(classifier-error-rate boost test-data-large) 0.03 0.001)
  
  (end-test-suite))
